diff -rupN seq24-rev48 adding win32/src/perfroll.cpp seq24-rev48 win32 adding MouseInteraction/src/perfroll.cpp
--- seq24-rev48 adding win32/src/perfroll.cpp	2009-05-20 20:30:47.031250000 -0500
+++ seq24-rev48 win32 adding MouseInteraction/src/perfroll.cpp	2009-05-20 20:30:51.281250000 -0500
@@ -47,8 +47,6 @@ perfroll::perfroll( perform *a_perf,
     m_vadjust = a_vadjust;
     m_hadjust = a_hadjust;
 
-    m_adding = false;
-    m_adding_pressed = false;
     m_moving = false;
     m_growing = false;
 
@@ -104,23 +102,6 @@ perfroll::change_vert( )
     }
 }
 
-/* popup menu calls this */
-void 
-perfroll::set_adding( bool a_adding )
-{
-    if ( a_adding ){
-
-	get_window()->set_cursor(  Gdk::Cursor( Gdk::PENCIL ));
-	m_adding = true;
-    
-    } else {
-
-	get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
-	m_adding = false;
-    }
-}
-
-
 void 
 perfroll::on_realize()
 {
@@ -620,168 +601,50 @@ perfroll::draw_drawable_row( Glib::RefPt
                           c_names_y );
 }
 
-bool
-perfroll::on_button_press_event(GdkEventButton* a_ev)
-{
-    grab_focus( ); 
-
-
-    if ( m_mainperf->is_active( m_drop_sequence ))
-    {
-        m_mainperf->get_sequence( m_drop_sequence )->unselect_triggers( );
-        draw_background_on( m_pixmap, m_drop_sequence );
-        draw_sequence_on( m_pixmap, m_drop_sequence );
-        draw_drawable_row( m_window, m_pixmap, m_drop_y);
-    }
-
-    m_drop_x = (int) a_ev->x;
-    m_drop_y = (int) a_ev->y;
-
-    convert_xy( m_drop_x, m_drop_y, &m_drop_tick, &m_drop_sequence );
-
-    /*      left mouse button     */
-    if ( a_ev->button == 1 ){
-
-        long tick = m_drop_tick;
-
-        /* add a new note if we didnt select anything */
-        if (  m_adding ){
-
-            m_adding_pressed = true;
-
-            if ( m_mainperf->is_active( m_drop_sequence )){
-
-                long seq_length = m_mainperf->get_sequence( m_drop_sequence )->get_length( );
-
-                bool state = m_mainperf->get_sequence( m_drop_sequence )->get_trigger_state( tick );
-
-                if ( state )
-                {
-                    m_mainperf->push_trigger_undo();
-                    m_mainperf->get_sequence( m_drop_sequence )->del_trigger( tick );
-                }
-                else
-                {
-
-                    // snap to length of sequence
-                    tick = tick - (tick % seq_length);
-                    m_adding_pressed_state = true;
-
-                    m_mainperf->push_trigger_undo();
-                    m_mainperf->get_sequence( m_drop_sequence )->add_trigger( tick, seq_length );
-                    draw_background_on( m_pixmap, m_drop_sequence );
-                    draw_sequence_on( m_pixmap, m_drop_sequence );
-                    draw_drawable_row( m_window, m_pixmap, m_drop_y);
-
-                    //m_drop_tick_last = (m_drop_tick + seq_length - 1);
-                }
-            }
-        }
-        else {
-
-            if ( m_mainperf->is_active( m_drop_sequence )){
-
-                m_mainperf->push_trigger_undo();
-                m_mainperf->get_sequence( m_drop_sequence )->select_trigger( tick );
-
-                long start_tick = m_mainperf->get_sequence( m_drop_sequence )->get_selected_trigger_start_tick();
-                long end_tick = m_mainperf->get_sequence( m_drop_sequence )->get_selected_trigger_end_tick();
-
-                if ( tick >= start_tick &&
-                        tick <= start_tick + (c_perfroll_size_box_click_w * c_perf_scale_x) &&
-                        (m_drop_y % c_names_y) <= c_perfroll_size_box_click_w + 1 )
-                {
-                    m_growing = true;
-                    m_grow_direction = true;
-                    m_drop_tick_trigger_offset = m_drop_tick -
-                        m_mainperf->get_sequence( m_drop_sequence )->
-                        get_selected_trigger_start_tick( );
-                }
-                else
-                    if ( tick >= end_tick - (c_perfroll_size_box_click_w * c_perf_scale_x) &&
-                            tick <= end_tick &&
-                            (m_drop_y % c_names_y) >= c_names_y - c_perfroll_size_box_click_w - 1 )
-                    {
-                        m_growing = true;
-                        m_grow_direction = false;
-                        m_drop_tick_trigger_offset =
-                            m_drop_tick -
-                            m_mainperf->get_sequence( m_drop_sequence )->get_selected_trigger_end_tick( );
-                    }
-                    else 
-                    {
-                        m_moving = true;
-                        m_drop_tick_trigger_offset = m_drop_tick -
-                            m_mainperf->get_sequence( m_drop_sequence )->
-                            get_selected_trigger_start_tick( );
 
-                    }
+void 
+perfroll::start_playing( void )
+{
+    // keep in sync with perfedit's start_playing... wish i could call it directly...
+    m_mainperf->position_jack( true );
+    m_mainperf->start_jack( );
+    m_mainperf->start( true );
+}
 
-                draw_background_on( m_pixmap, m_drop_sequence );
-                draw_sequence_on( m_pixmap, m_drop_sequence );
-                draw_drawable_row( m_window, m_pixmap, m_drop_y);
-            }
-        }        
-    }
+void
+perfroll::stop_playing( void )
+{ 
+    // keep in sync with perfedit's stop_playing... wish i could call it directly...
+    m_mainperf->stop_jack(); 
+    m_mainperf->stop();
+}
 
-    /*     right mouse button      */
-    if ( a_ev->button == 3 ){
-        set_adding( true );
-    }
 
-    /* middle, split */
-    if ( a_ev->button == 2 )
+bool
+perfroll::on_button_press_event(GdkEventButton* a_ev)
+{
+    switch (global_interactionmethod)
     {
-        long tick = m_drop_tick;
-
-        if ( m_mainperf->is_active( m_drop_sequence )){
-
-            bool state = m_mainperf->get_sequence( m_drop_sequence )->get_trigger_state( tick );
-
-            if ( state )
-            {
-                m_mainperf->push_trigger_undo();
-
-                m_mainperf->get_sequence( m_drop_sequence )->split_trigger( tick );
-
-                draw_background_on( m_pixmap, m_drop_sequence );
-                draw_sequence_on( m_pixmap, m_drop_sequence );
-                draw_drawable_row( m_window, m_pixmap, m_drop_y);
-            }
-        }
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_press_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_press_event(a_ev, *this);
     }
-    return true;
+    return false;
 }
 
 
 bool
 perfroll::on_button_release_event(GdkEventButton* a_ev)
 {
-    
-    if ( a_ev->button == 1 ){
-
-        if ( m_adding ){
-            m_adding_pressed = false;
-        }
-    }
-
-    else if ( a_ev->button == 3 ){
-	m_adding_pressed = false;
- 	set_adding( false );
-    }
-    
-    m_moving = false;
-    m_growing = false;
-    m_adding_pressed = false;
-
-    if ( m_mainperf->is_active( m_drop_sequence  )){
-        
-        draw_background_on( m_pixmap, m_drop_sequence );
-        draw_sequence_on( m_pixmap, m_drop_sequence );
-        draw_drawable_row( m_window, m_pixmap, m_drop_y );
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_release_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_release_event(a_ev, *this);
     }
-    
-    return true;
+    return false;
 }
 
 bool
@@ -824,59 +687,14 @@ perfroll::on_scroll_event( GdkEventScrol
 bool
 perfroll::on_motion_notify_event(GdkEventMotion* a_ev)
 {
-
-    long tick;
-    int x = (int) a_ev->x;
-    
-    if (  m_adding && m_adding_pressed ){
-        
-	convert_x( x, &tick );
-
-	if ( m_mainperf->is_active( m_drop_sequence )){
-
-            long seq_length = m_mainperf->get_sequence( m_drop_sequence )->get_length( );
-            tick = tick - (tick % seq_length);
-
-            /*long min_tick = (tick < m_drop_tick) ? tick : m_drop_tick;*/
-            long length = seq_length;
-            
-	    m_mainperf->get_sequence( m_drop_sequence )->grow_trigger( m_drop_tick, tick, length);
-	    draw_background_on( m_pixmap, m_drop_sequence );
-	    draw_sequence_on( m_pixmap, m_drop_sequence );
-            draw_drawable_row( m_window, m_pixmap, m_drop_y);
-	}
-    }
-    else if ( m_moving || m_growing ){
-
-        if ( m_mainperf->is_active( m_drop_sequence)){
-            
-            convert_x( x, &tick );
-            tick -= m_drop_tick_trigger_offset;
-
-            tick = tick - tick % m_snap;
-
-            if ( m_moving )
-            {
-                m_mainperf->get_sequence( m_drop_sequence )->move_selected_triggers_to( tick, true );
-            }
-            if ( m_growing )
-            {
-                if ( m_grow_direction )
-                    m_mainperf->get_sequence( m_drop_sequence )->move_selected_triggers_to( tick, false, 0 );
-                else
-                    m_mainperf->get_sequence( m_drop_sequence )->move_selected_triggers_to( tick-1, false, 1 );
-            }
-
-            
-            draw_background_on( m_pixmap, m_drop_sequence );
-            draw_sequence_on( m_pixmap, m_drop_sequence );
-            draw_drawable_row( m_window, m_pixmap, m_drop_y);
-        }
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_motion_notify_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_motion_notify_event(a_ev, *this);
     }
-
-    
-
-    return true;
+    return false;
 }
 
 bool 
@@ -1013,3 +831,522 @@ void 
 perfroll::on_size_request(GtkRequisition* a_r )
 {
 }
+
+
+
+
+//////////////////////////
+// interaction methods
+//////////////////////////
+
+
+void FruityPerfInput::updateMousePtr( perfroll& ths )
+{
+    // context sensitive mouse
+    long drop_tick;
+    int drop_sequence;
+    ths.convert_xy( m_current_x, m_current_y, &drop_tick, &drop_sequence );
+    if (ths.m_mainperf->is_active( drop_sequence ))
+    {
+         long start, end;
+         if (ths.m_mainperf->get_sequence(drop_sequence)->intersectTriggers( drop_tick, start, end ))
+	     {
+             if (start <= drop_tick && drop_tick <= start + (c_perfroll_size_box_click_w * c_perf_scale_x) &&
+                 (m_current_y % c_names_y) <= c_perfroll_size_box_click_w + 1)
+             {
+                ths.get_window()->set_cursor( Gdk::Cursor( Gdk::RIGHT_PTR ));
+             }
+             else if (end - (c_perfroll_size_box_click_w * c_perf_scale_x) <= drop_tick && drop_tick <= end &&
+                      (m_current_y % c_names_y) >= c_names_y - c_perfroll_size_box_click_w - 1)
+             {
+                ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
+             }
+             else
+             {
+                ths.get_window()->set_cursor( Gdk::Cursor( Gdk::CENTER_PTR ));
+             }
+         }
+         else
+         {
+             ths.get_window()->set_cursor( Gdk::Cursor( Gdk::PENCIL ));
+         }
+    }
+    else
+    {
+        ths.get_window()->set_cursor( Gdk::Cursor( Gdk::CROSSHAIR ));
+    }
+}
+
+
+bool FruityPerfInput::on_button_press_event(GdkEventButton* a_ev, perfroll& ths)
+{
+    ths.grab_focus( );
+
+    if ( ths.m_mainperf->is_active( ths.m_drop_sequence ))
+    {
+        ths.m_mainperf->get_sequence( ths.m_drop_sequence )->unselect_triggers( );
+        ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+    }
+
+    ths.m_drop_x = (int) a_ev->x;
+    ths.m_drop_y = (int) a_ev->y;
+    m_current_x = (int) a_ev->x;
+    m_current_y = (int) a_ev->y;
+
+
+    ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &ths.m_drop_tick, &ths.m_drop_sequence );
+
+    /*      left mouse button     */
+    if ( a_ev->button == 1 && !(a_ev->state & GDK_CONTROL_MASK)){
+
+        long tick = ths.m_drop_tick;
+
+        /* add a new note if we didnt select anything */
+        //if (  m_adding )
+        {
+
+            m_adding_pressed = true;
+
+            if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+                long seq_length = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_length( );
+
+                bool state = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_trigger_state( tick );
+
+                // resize the event, or move it, depending on where clicked.
+                if ( state )
+                {
+                    //m_adding = false;
+                    m_adding_pressed = false;
+                    ths.m_mainperf->push_trigger_undo();
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )->select_trigger( tick );
+
+                    long start_tick = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_selected_trigger_start_tick();
+                    long end_tick = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_selected_trigger_end_tick();
+
+                    if ( tick >= start_tick &&
+                            tick <= start_tick + (c_perfroll_size_box_click_w * c_perf_scale_x) &&
+                            (ths.m_drop_y % c_names_y) <= c_perfroll_size_box_click_w + 1 )
+                    {
+                        // clicked left side: begin a grow/shrink for the left side
+                        ths.m_growing = true;
+                        ths.m_grow_direction = true;
+                        ths.m_drop_tick_trigger_offset = ths.m_drop_tick -
+                            ths.m_mainperf->get_sequence( ths.m_drop_sequence )->
+                            get_selected_trigger_start_tick( );
+                    }
+                    else
+                        if ( tick >= end_tick - (c_perfroll_size_box_click_w * c_perf_scale_x) &&
+                                tick <= end_tick &&
+                                (ths.m_drop_y % c_names_y) >= c_names_y - c_perfroll_size_box_click_w - 1 )
+                        {
+                            // clicked right side: grow/shrink the right side
+                            ths.m_growing = true;
+                            ths.m_grow_direction = false;
+                            ths.m_drop_tick_trigger_offset =
+                                ths.m_drop_tick -
+                                ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_selected_trigger_end_tick( );
+                        }
+                        else
+                        {
+                             // clicked in the middle - move it
+                            ths.m_moving = true;
+                            ths.m_drop_tick_trigger_offset = ths.m_drop_tick -
+                                ths.m_mainperf->get_sequence( ths.m_drop_sequence )->
+                                get_selected_trigger_start_tick( );
+
+                        }
+
+                    ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+                    ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+                    ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+                }
+
+                // add an event:
+                else
+                {
+
+                    // snap to length of sequence
+                    tick = tick - (tick % seq_length);
+
+                    ths.m_mainperf->push_trigger_undo();
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )->add_trigger( tick, seq_length );
+                    ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+                    ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+                    ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+
+                    //m_drop_tick_last = (m_drop_tick + seq_length - 1);
+                }
+            }
+        }
+    }
+
+    /*     right mouse button      */
+    if ( a_ev->button == 3 ){
+        //set_adding( false );
+
+        long tick = ths.m_drop_tick;
+
+        if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+            long seq_length = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_length( );
+
+            bool state = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_trigger_state( tick );
+
+            if ( state )
+            {
+                ths.m_mainperf->push_trigger_undo();
+                ths.m_mainperf->get_sequence( ths.m_drop_sequence )->del_trigger( tick );
+            }
+        }
+    }
+
+    /* left-ctrl, or middle: split */
+    if ( a_ev->button == 2 ||
+         a_ev->button == 1 && (a_ev->state & GDK_CONTROL_MASK) )
+    {
+        long tick = ths.m_drop_tick;
+
+        if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+            bool state = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_trigger_state( tick );
+
+            if ( state )
+            {
+                ths.m_mainperf->push_trigger_undo();
+
+                ths.m_mainperf->get_sequence( ths.m_drop_sequence )->split_trigger( tick );
+
+                ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+                ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+                ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+            }
+        }
+    }
+    updateMousePtr( ths );
+    return true;
+}
+
+bool FruityPerfInput::on_button_release_event(GdkEventButton* a_ev, perfroll& ths)
+{
+    m_current_x = (int) a_ev->x;
+    m_current_y = (int) a_ev->y;
+
+    if ( a_ev->button == 1 || a_ev->button == 3 )
+    {
+        m_adding_pressed = false;
+    }
+
+    ths.m_moving = false;
+    ths.m_growing = false;
+    m_adding_pressed = false;
+
+    if ( ths.m_mainperf->is_active( ths.m_drop_sequence  )){
+
+        ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y );
+    }
+
+    updateMousePtr( ths );
+    return true;
+}
+
+bool FruityPerfInput::on_motion_notify_event(GdkEventMotion* a_ev, perfroll& ths)
+{
+    long tick;
+    int x = (int) a_ev->x;
+    m_current_x = (int) a_ev->x;
+    m_current_y = (int) a_ev->y;
+    
+    if (  m_adding_pressed ){
+
+    	ths.convert_x( x, &tick );
+
+        if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+            long seq_length = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_length( );
+            tick = tick - (tick % seq_length);
+
+            /*long min_tick = (tick < m_drop_tick) ? tick : m_drop_tick;*/
+            long length = seq_length;
+
+    	    ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                          ->grow_trigger( ths.m_drop_tick, tick, length);
+    	    ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+    	    ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+            ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+    	}
+    }
+    else if ( ths.m_moving || ths.m_growing )
+    {
+        if ( ths.m_mainperf->is_active( ths.m_drop_sequence))
+        {
+            ths.convert_x( x, &tick );
+            tick -= ths.m_drop_tick_trigger_offset;
+
+            tick = tick - tick % ths.m_snap;
+
+            if ( ths.m_moving )
+            {
+                ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                              ->move_selected_triggers_to( tick, true );
+            }
+            if ( ths.m_growing )
+            {
+                if ( ths.m_grow_direction )
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                                  ->move_selected_triggers_to( tick, false, 0 );
+                else
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                                  ->move_selected_triggers_to( tick-1, false, 1 );
+            }
+
+
+            ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+            ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+            ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+        }
+    }
+
+    updateMousePtr( ths );
+    return true;
+}
+
+
+/* popup menu calls this */
+void
+Seq24PerfInput::set_adding( bool a_adding, perfroll& ths )
+{
+    if ( a_adding )
+    {
+	   ths.get_window()->set_cursor(  Gdk::Cursor( Gdk::PENCIL ));
+	   m_adding = true;
+    }
+    else
+    {
+	    ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
+	    m_adding = false;
+    }
+}
+
+bool
+Seq24PerfInput::on_button_press_event(GdkEventButton* a_ev, perfroll& ths)
+{
+    ths.grab_focus( );
+
+
+    if ( ths.m_mainperf->is_active( ths.m_drop_sequence ))
+    {
+        ths.m_mainperf->get_sequence( ths.m_drop_sequence )->unselect_triggers( );
+        ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+    }
+
+    ths.m_drop_x = (int) a_ev->x;
+    ths.m_drop_y = (int) a_ev->y;
+
+    ths.convert_xy( ths.m_drop_x, ths.m_drop_y, &ths.m_drop_tick, &ths.m_drop_sequence );
+
+    /*      left mouse button     */
+    if ( a_ev->button == 1 ){
+
+        long tick = ths.m_drop_tick;
+
+        /* add a new note if we didnt select anything */
+        if (  m_adding ){
+
+            m_adding_pressed = true;
+
+            if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+                long seq_length = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_length( );
+
+                bool state = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_trigger_state( tick );
+
+                if ( state )
+                {
+                    ths.m_mainperf->push_trigger_undo();
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )->del_trigger( tick );
+                }
+                else
+                {
+
+                    // snap to length of sequence
+                    tick = tick - (tick % seq_length);
+                    //m_adding_pressed_state = true;
+
+                    ths.m_mainperf->push_trigger_undo();
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )->add_trigger( tick, seq_length );
+                    ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+                    ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+                    ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+
+                    //m_drop_tick_last = (m_drop_tick + seq_length - 1);
+                }
+            }
+        }
+        else {
+
+            if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+                ths.m_mainperf->push_trigger_undo();
+                ths.m_mainperf->get_sequence( ths.m_drop_sequence )->select_trigger( tick );
+
+                long start_tick = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_selected_trigger_start_tick();
+                long end_tick = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_selected_trigger_end_tick();
+
+                if ( tick >= start_tick &&
+                        tick <= start_tick + (c_perfroll_size_box_click_w * c_perf_scale_x) &&
+                        (ths.m_drop_y % c_names_y) <= c_perfroll_size_box_click_w + 1 )
+                {
+                    ths.m_growing = true;
+                    ths.m_grow_direction = true;
+                    ths.m_drop_tick_trigger_offset = ths.m_drop_tick -
+                        ths.m_mainperf->get_sequence( ths.m_drop_sequence )->
+                                        get_selected_trigger_start_tick( );
+                }
+                else
+                    if ( tick >= end_tick - (c_perfroll_size_box_click_w * c_perf_scale_x) &&
+                            tick <= end_tick &&
+                            (ths.m_drop_y % c_names_y) >= c_names_y - c_perfroll_size_box_click_w - 1 )
+                    {
+                        ths.m_growing = true;
+                        ths.m_grow_direction = false;
+                        ths.m_drop_tick_trigger_offset =
+                            ths.m_drop_tick -
+                            ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_selected_trigger_end_tick( );
+                    }
+                    else 
+                    {
+                        ths.m_moving = true;
+                        ths.m_drop_tick_trigger_offset = ths.m_drop_tick -
+                            ths.m_mainperf->get_sequence( ths.m_drop_sequence )->
+                                            get_selected_trigger_start_tick( );
+
+                    }
+
+                ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+                ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+                ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+            }
+        }        
+    }
+
+    /*     right mouse button      */
+    if ( a_ev->button == 3 ){
+        set_adding( true, ths );
+    }
+
+    /* middle, split */
+    if ( a_ev->button == 2 )
+    {
+        long tick = ths.m_drop_tick;
+
+        if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+            bool state = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_trigger_state( tick );
+
+            if ( state )
+            {
+                ths.m_mainperf->push_trigger_undo();
+
+                ths.m_mainperf->get_sequence( ths.m_drop_sequence )->split_trigger( tick );
+
+                ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+                ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+                ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+            }
+        }
+    }
+    return true;
+}
+
+bool Seq24PerfInput::on_button_release_event(GdkEventButton* a_ev, perfroll& ths)
+{
+    if ( a_ev->button == 1 ){
+
+        if ( m_adding ){
+            m_adding_pressed = false;
+        }
+    }
+
+    if ( a_ev->button == 3 ){
+	m_adding_pressed = false;
+ 	set_adding( false, ths );
+    }
+    
+    ths.m_moving = false;
+    ths.m_growing = false;
+    m_adding_pressed = false;
+
+    if ( ths.m_mainperf->is_active( ths.m_drop_sequence  )){
+        
+        ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+        ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y );
+    }
+    
+    return true;
+}
+
+bool Seq24PerfInput::on_motion_notify_event(GdkEventMotion* a_ev, perfroll& ths)
+{
+    long tick;
+    int x = (int) a_ev->x;
+    
+    if (  m_adding && m_adding_pressed ){
+        
+    	ths.convert_x( x, &tick );
+
+    	if ( ths.m_mainperf->is_active( ths.m_drop_sequence )){
+
+            long seq_length = ths.m_mainperf->get_sequence( ths.m_drop_sequence )->get_length( );
+            tick = tick - (tick % seq_length);
+
+            /*long min_tick = (tick < m_drop_tick) ? tick : m_drop_tick;*/
+            long length = seq_length;
+            
+    	    ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                          ->grow_trigger( ths.m_drop_tick, tick, length);
+    	    ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+    	    ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+            ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+    	}
+    }
+    else if ( ths.m_moving || ths.m_growing ){
+
+        if ( ths.m_mainperf->is_active( ths.m_drop_sequence)){
+            
+            ths.convert_x( x, &tick );
+            tick -= ths.m_drop_tick_trigger_offset;
+
+            tick = tick - tick % ths.m_snap;
+
+            if ( ths.m_moving )
+            {
+                ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                              ->move_selected_triggers_to( tick, true );
+            }
+            if ( ths.m_growing )
+            {
+                if ( ths.m_grow_direction )
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                                  ->move_selected_triggers_to( tick, false, 0 );
+                else
+                    ths.m_mainperf->get_sequence( ths.m_drop_sequence )
+                                  ->move_selected_triggers_to( tick-1, false, 1 );
+            }
+
+            
+            ths.draw_background_on( ths.m_pixmap, ths.m_drop_sequence );
+            ths.draw_sequence_on( ths.m_pixmap, ths.m_drop_sequence );
+            ths.draw_drawable_row( ths.m_window, ths.m_pixmap, ths.m_drop_y);
+        }
+    }
+
+    return true;
+}
diff -rupN seq24-rev48 adding win32/src/perfroll.h seq24-rev48 win32 adding MouseInteraction/src/perfroll.h
--- seq24-rev48 adding win32/src/perfroll.h	2009-05-20 20:30:47.046875000 -0500
+++ seq24-rev48 win32 adding MouseInteraction/src/perfroll.h	2009-05-20 20:30:51.312500000 -0500
@@ -45,12 +45,41 @@
 
 using namespace Gtk;
 
+class perfroll;
+struct FruityPerfInput
+{
+    FruityPerfInput() : m_adding_pressed( false ), m_current_x( 0 ),
+                         m_current_y( 0 )
+    {}
+    bool on_button_press_event(GdkEventButton* a_ev, perfroll& ths);
+    bool on_button_release_event(GdkEventButton* a_ev, perfroll& ths);
+    bool on_motion_notify_event(GdkEventMotion* a_ev, perfroll& ths);
+    void updateMousePtr(perfroll& ths);
+    bool m_adding_pressed;
+    long m_current_x, m_current_y;
+};
+struct Seq24PerfInput
+{
+    Seq24PerfInput() : m_adding( false ), m_adding_pressed( false ) {}
+    bool on_button_press_event(GdkEventButton* a_ev, perfroll& ths);
+    bool on_button_release_event(GdkEventButton* a_ev, perfroll& ths);
+    bool on_motion_notify_event(GdkEventMotion* a_ev, perfroll& ths);
+    void set_adding( bool a_adding, perfroll& ths );
+    bool m_adding;
+    bool m_adding_pressed;
+};
 
 /* performance roll */
 class perfroll : public Gtk::DrawingArea
 {
 
  private: 
+    friend struct FruityPerfInput;
+    FruityPerfInput m_fruity_interaction;
+
+    friend struct Seq24PerfInput;
+    Seq24PerfInput m_seq24_interaction;
+
 
     Glib::RefPtr<Gdk::GC> m_gc;
     Glib::RefPtr<Gdk::Window> m_window;
@@ -86,9 +115,6 @@ class perfroll : public Gtk::DrawingArea
     Adjustment   *m_vadjust;
     Adjustment   *m_hadjust;
 
-    bool m_adding;
-    bool m_adding_pressed;
-    bool m_adding_pressed_state;
     bool m_moving;
     bool m_growing;
     bool m_grow_direction;
@@ -113,6 +139,10 @@ class perfroll : public Gtk::DrawingArea
     void snap_x( int *a_x );
 
    
+    void start_playing( void );
+    void stop_playing( void );
+
+   
 
     void draw_sequence_on( Glib::RefPtr<Gdk::Drawable> a_draw, int a_sequence );
     void draw_background_on( Glib::RefPtr<Gdk::Drawable> a_draw, int a_sequence );
@@ -136,8 +166,6 @@ class perfroll : public Gtk::DrawingArea
 
     void draw_progress();
 
-    void set_adding( bool a_adding );
-
     void redraw_dirty_sequences( void );
 
     perfroll( perform *a_perf, 
